/* $Id: dl_append.c,v 0.3 1998/05/03 21:43:52 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_append.c,v $
 * Revision 0.3  1998/05/03 21:43:52  rsmit06
 * Changed copyright date.
 *
 * Revision 0.2  1998/05/03 20:14:19  rsmit06
 * New parameters, new code. Added assertions.
 *
 * Revision 0.1  1997/12/21 16:48:22  rsmit06
 * Initial code
 *
 */

#include <assert.h>
#include "dlist.h"

extern struct _dlink *
dl_calloc(unsigned cb, void *pdata, int type);

void dl_append(dlist_p list, unsigned cb, void *pdata, int type)
{
  struct _dlink *newlink;
  /* Check parameters */
  assert(list != 0);
  /* Allocate new link. */
  newlink = dl_calloc(cb, pdata, type);
  if (list->tail == 0) {
    /* In case of an empty list */
    list->head = list->tail = list->current = newlink;
    list->num_items = 1;
  } else {
    /* Update the link's pointers. */
    newlink->next = 0;
    newlink->prev = list->tail;
    /* Update the list */
    list->tail->next = newlink;
    if (list->tail == list->current)
      list->current = newlink;
    list->tail = newlink;
    list->num_items++;
  }
}
