/* $Id: dl_calloc.c,v 0.4 1998/05/03 21:45:07 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_calloc.c,v $
 * Revision 0.4  1998/05/03 21:45:07  rsmit06
 * Changed copyright date.
 *
 * Revision 0.3  1998/05/03 19:59:55  rsmit06
 * Added assertions.
 *
 * Revision 0.2  1997/12/21 21:50:51  rsmit06
 * Added parameter check. Either cb or pdata can be 0, but not both.
 *
 * Revision 0.1  1997/12/21 16:48:42  rsmit06
 * Initial code
 *
 */

#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "dlist.h"

struct _dlink *
dl_calloc(unsigned cb, void *pdata, int type)
{
  struct _dlink *link;
  /* Check parameters */
  assert(!(cb == 0 && pdata == 0));
  /* Allocate memory and check. */
  link = calloc(1, sizeof(struct _dlink)+cb);
  assert(link != 0);
  if (cb != 0) {
    /* Set data pointer to area after the link structure proper. */
    link->pdata = (void*)(link+1);
  }
  /* Set type */
  link->type = type;
  /* Set data size */
  link->cb_xtra = cb;
  if (pdata) {
    if (cb == 0) {
      /* Set pointer to data if no space allocated. */
      link->pdata = pdata;
    } else {
      /* Copy data from valid data pointer. */
      memcpy(link->pdata, pdata, cb);
    }
  }
  return link;
}
