/* $Id: dl_current.c,v 1.3 1998/05/03 21:47:02 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_current.c,v $
 * Revision 1.3  1998/05/03 21:47:02  rsmit06
 * Changed copyright date.
 *
 * Revision 1.2  1998/05/03 20:16:13  rsmit06
 * Added assertions.
 *
 * Revision 1.1  1998/05/03 19:29:10  rsmit06
 * Initial revision
 *
 *
 */

#include <assert.h>
#include "dlist.h"

void *
dl_cur_data(dlist_p list)
{
  /* Check the argument. */
  assert(list != 0);
  /* Check for empty list. */
  if (list->current == 0)
    return 0;
  /* Return pointer to the data of the current link. */
  return list->current->pdata;
}

int 
dl_cur_type(dlist_p list)
{
  /* Check the argument. */
  assert(list != 0);
  /* Check for empty list. */
  if (list->current == 0)
    return 0;
  /* Return the current link's data type. */
  return list->current->type;
}

unsigned
dl_cur_size(dlist_p list)
{
  /* Check the argument. */
  assert(list != 0);
  /* Check for empty list. */
  if (list->current == 0)
    return 0;
  /* Return the current link's extra allocated size. */
  return list->current->cb_xtra;
}
