/* $Id: dl_erase.c,v 1.3 1998/05/03 21:05:07 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_erase.c,v $
 * Revision 1.3  1998/05/03 21:05:07  rsmit06
 * Line 49: removed separate freeing of current->pdata (bug).
 *
 * Revision 1.2  1998/05/03 19:56:59  rsmit06
 * Changed strings.h top string.h
 *
 * Revision 1.1  1998/05/03 19:52:30  rsmit06
 * Initial revision
 *
 *
 */

#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "dlist.h"

void
dl_erase(dlist_p list)
{
  struct _dlink *current;

  /* Check the parameters. */
  assert(list != 0);
  /* Empty list: do nothing. */
  if (list->head == 0)
    return;
  /* Free all items. */
  current = list->head;
  while (current) {
    struct _dlink *next = current->next;
    free(current);
    current = next;
  }
  /* Re-initialize the list */
  memset(list, 0, sizeof(struct _dlist));
}


