/* $Id: dl_first.c,v 0.5 1998/05/03 21:49:14 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_first.c,v $
 * Revision 0.5  1998/05/03 21:49:14  rsmit06
 * Changed copyright date.
 *
 * Revision 0.4  1998/05/03 21:16:08  rsmit06
 * Line 47: changed lisr to list.
 *
 * Revision 0.3  1998/05/03 20:22:34  rsmit06
 * Line 42: changed comparision into assignment.
 *
 * Revision 0.2  1998/05/03 20:20:37  rsmit06
 * Added assertion and current pointer. Changed function type.
 *
 * Revision 0.1  1997/12/21 16:50:27  rsmit06
 * Initial code
 *
 */

#include <assert.h>
#include "dlist.h"

void *
dl_first(dlist_p list)
{
  /* Check parameters. */
  assert(list != 0);
  /* Check for empty list. */
  if (list->head == 0)
    return 0;
  /* Set current pointer. */
  list->current = list->head;
  /* Return pointer to current's data. */
  return list->current->pdata;
}
