/* $Id: dl_next.c,v 0.3 1998/05/03 21:49:53 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_next.c,v $
 * Revision 0.3  1998/05/03 21:49:53  rsmit06
 * Changed copyright date.
 *
 * Revision 0.2  1998/05/03 20:34:49  rsmit06
 * Added assertion. Return type changed. New code.
 *
 * Revision 0.1  1997/12/21 16:51:01  rsmit06
 * Initial code
 *
 */

#include <assert.h>
#include "dlist.h"

void * 
dl_next(dlist_p list)
{
  /* Check parameters */
  assert(list != 0);
  if (list->tail == 0)
    return 0;
  /* Bail out if already at the end of the list. */
  if (list->current == list->tail)
    return 0;
  /* Move to next list item. */
  list->current = list->current->next;
  /* Return data pointer. */
  return list->current->pdata;
}
