/* $Id: dl_prev.c,v 0.3 1998/05/03 20:38:44 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_prev.c,v $
 * Revision 0.3  1998/05/03 20:38:44  rsmit06
 * Included assert.h.
 *
 * Revision 0.2  1998/05/03 20:38:05  rsmit06
 * Added assertion. New code. Changed return type.
 *
 * Revision 0.1  1997/12/21 16:51:29  rsmit06
 * Initial code
 *
 */

#include <assert.h>
#include "dlist.h"

void *
dl_prev(dlist_p list)
{
  /* Check parameters */
  assert(list != 0);
  if (list->head == 0)
    return 0;
  /* Bail out if already at the start of the list. */
  if (list->current == list->head)
    return 0;
  /* Move to previous list item. */
  list->current = list->current->prev;
  /* Return data pointer. */
  return list->current->pdata;
}
