/* $Id: dl_rm.c,v 0.3 1998/05/03 21:12:56 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_rm.c,v $
 * Revision 0.3  1998/05/03 21:12:56  rsmit06
 * Added assertion. Removed freeing of ret->pdata.
 *
 * Revision 0.2  1998/05/03 19:30:34  rsmit06
 * *** empty log message ***
 *
 * Revision 0.1  1997/12/21 22:43:05  rsmit06
 * Initial code
 *
 *
 */

#include <stdlib.h>
#include <assert.h>
#include "dlist.h"

void 
dl_rm(dlist_p list)
{
  /* Check parameters. */
  assert (list != 0);
  /* Return if the list is empty. */
  if (list->head == 0) {
    return;
  }
  /* Remove the current link. */
  if (list->current == list->head) {
    dl_rm_head(list);
  } else if (list->current == list->tail) {
    dl_rm_tail(list);
  } else {
    struct _dlink *l = list->current;
    struct _dlink *p = list->current->prev;
    struct _dlink *n = list->current->next;
    p->next = n;
    n->prev = p;
    l->prev = l->next = 0;
    free(l);
    list->num_items--;
  }
}
