/* $Id: dl_rm_head.c,v 0.4 1998/05/03 21:09:24 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_rm_head.c,v $
 * Revision 0.4  1998/05/03 21:09:24  rsmit06
 * Included assert.h
 *
 * Revision 0.3  1998/05/03 21:05:56  rsmit06
 * Removed freeing of ret->pdata (bug).
 *
 * Revision 0.2  1998/05/03 21:01:50  rsmit06
 * Added assertion. Changed copyright date. Restrutured the code.
 *
 * Revision 0.1  1997/12/21 16:51:45  rsmit06
 * Initial code
 *
 */

#include <stdlib.h>
#include <assert.h>
#include "dlist.h"

void 
dl_rm_head(dlist_p list)
{
  struct _dlink *ret = 0;
  /* Check parameter */
  assert(list != 0);
  /* Check for an empty list. */
  if (list->head == 0)
    return;
  /* Get the link to be returned. */
  ret = list->head;
  /* Update the list. */
  if (list->head == list->tail) { 
    /* Only one link in the list. */
    list->head = list->tail = list->current = 0;
    list->num_items = 0;
  } else {
    if (list->current == list->head)
      list->current = list->head->next;
    /* Set the new list head. */
    list->head = list->head->next;
    list->head->prev = 0;
    list->num_items--;
  }
  /* Free the data. */
  ret->prev = ret->next = 0;
  free(ret);
}
