/* $Id: dl_rm_tail.c,v 0.4 1998/05/03 21:20:38 rsmit06 Stab $
 *
 * This file is part of the dlist library.
 *
 * Copyright (C) 1997, 1998  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dl_rm_tail.c,v $
 * Revision 0.4  1998/05/03 21:20:38  rsmit06
 * Line 42: Changed link to list.
 *
 * Revision 0.3  1998/05/03 21:10:28  rsmit06
 * Added assertion. Changed copyright date.
 *
 * Revision 0.2  1998/05/03 19:29:53  rsmit06
 * *** empty log message ***
 *
 * Revision 0.1  1997/12/21 16:51:57  rsmit06
 * Initial code
 *
 */

#include <stdlib.h>
#include <assert.h>
#include "dlist.h"

void 
dl_rm_tail(dlist_p list)
{
  struct _dlink *ret = 0;
  /* Check parameter */
  assert(list != 0);
  /* Check for an empty list. */
  if (list->tail == 0)
    return;
  /* Get the link to be returned. Set its linking fields to 0. */
  ret = list->tail;
  /* Remove the link from the list. */
  if (list->head == list->tail) {
    list->head = list->tail = list->current = 0;
    list->num_items = 0;
  } else {
    if (list->current == list->tail)
      list->current = list->tail->prev;
    list->tail = list->tail->prev;
    list->tail->next = 0;
    list->num_items--;
  }
  /* Free the link. */
  ret->prev = ret->next = 0;
  free(ret);
}
