/* listtest.c
 * Test program for the dlist library.
 * R.F. Smith, 1997
 * gcc -O2 -s -o listtest listtest.c -L. -I. -ldlist_s
 */

#include <stdio.h>
#include "dlist.h"

int main(int argc, char *argv[])
{
  dlist_p list;
  void *link;
  int t;

  /* Create a link */
  list = dl_create();

  /* Add some links */
  for (t=0; t<100; t++) {
    printf("Adding list entry %d ... ", t);
    dl_append(list, 512, 0, t);
    printf("done\n");
  }

  link = dl_first(list);
  while (link) {
    printf("link %p, type %d, size %u\n", link,
           dl_cur_type(list), dl_cur_size(list));
    link = dl_next(list);
  }

  /* Remove some links */
  for (t=0; t<10; t++) {
    printf("removing link from head...");
    dl_rm_head(list);
    printf("done\n");
    printf("removing link from tail...");
    dl_rm_tail(list);
    printf("done\n");
  }

  link = dl_first(list);
  while (link) {
    printf("link %p, type %d, size %u\n", link, 
           dl_cur_type(list), dl_cur_size(list));
    link = dl_next(list);
  }

  dl_destroy(list);

}
